# react-hooks &middot; [<img alt="Version" src="https://img.shields.io/npm/v/@flywire/react-hooks.svg">](https://www.npmjs.com/package/@flywire/react-hooks) [<img alt="Size" src="https://img.shields.io/bundlephobia/min/@flywire/react-hooks">](https://bundlephobia.com/result?p=@flywire/react-hooks)

![react-hooks](./fly-hooks.svg)

A collection of Reacts hooks used in Flywire

## Install

Add the dependency to your `package.json`:

```bash
npm i @flywire/react-hooks
```

## Development

Install dependencies:

```javascript
npm install
```

## Run tests

```sh
npm run test
```

## Hooks

- [useCookie](src/hooks/useCookie/README.md)
- [useDebounce](src/hooks/useDebounce/README.md)
- [useFormState](src/hooks/useFormState/README.md)
- [useIdleTimer](src/hooks/useIdleTimer/README.md)
- [useLocalStorageState](src/hooks/useLocalStorageState/README.md)
- [useOnClickOutside](src/hooks/useOnClickOutside/README.md)
- [useOnScroll](src/hooks/useOnScroll/README.md)
- [useStep](src/hooks/useStep/README.md)
- [useThrottle](src/hooks/useThrottle/README.md)
- [useToggle](src/hooks/useToggle/README.md)
- [useValidate](src/hooks/useValidate/README.md)

## Releases

To create a new release, make all the changes that you need and commit them,
then execute:

```bash
npm version [<newversion> | major | minor | patch | premajor | preminor | prepatch | prerelease | from-git]
```

For example:

```bash
npm version patch
npm publish
```

or for a beta:

```bash
npm version prepatch
npm publish --tag beta
```

This will bump the `package.json` version, build a new bundle, commit, push the
changes tagging them to a new release.

Then create a PR and request the review from other project commiters. Once
accepted and merged to master, execute `npm publish` from master branch.
