"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
function useDebounce(value, delay) {
    const [nextValue, setNextValue] = (0, react_1.useState)(value);
    (0, react_1.useEffect)(() => {
        const timeoutId = setTimeout(() => {
            setNextValue(value);
        }, delay);
        return () => {
            clearTimeout(timeoutId);
        };
    }, [value, delay]);
    return nextValue;
}
exports.default = useDebounce;
