"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useOnClickOutside = (ref, callback) => {
    const handler = (0, react_1.useCallback)((evt) => {
        if (ref && ref.current && !ref.current.contains(evt.target)) {
            callback();
        }
    }, [ref, callback]);
    (0, react_1.useEffect)(() => {
        document.addEventListener('click', handler);
        document.addEventListener('ontouchstart', handler);
        return () => {
            document.removeEventListener('click', handler);
            document.removeEventListener('ontouchstart', handler);
        };
    }, [handler]);
};
exports.default = useOnClickOutside;
