"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
function useThrottle(value, delay, wallclock = 0) {
    const lastTime = (0, react_1.useRef)(wallclock);
    const [nextValue, setNextValue] = (0, react_1.useState)(value);
    (0, react_1.useEffect)(() => {
        const now = Date.now();
        if (now - lastTime.current >= delay) {
            lastTime.current = now;
            setNextValue(value);
        }
    }, [value, delay]);
    return nextValue;
}
exports.default = useThrottle;
