export declare enum actionTypes {
    VALIDATION_SUCCESS = "VALIDATION_SUCCESS",
    VALIDATION_ERROR = "VALIDATION_ERROR"
}
export type Errors = {
    [key: string]: string[];
};
export type Data = {
    [key: string]: string | boolean | null;
};
export type Constraints = {
    [key: string]: {
        [key: string]: unknown;
    };
};
export type Options = {
    onError?: (errors: Errors) => void;
    onSuccess?: () => void;
};
export type State = {
    errors: Errors;
    isValid: boolean;
};
export type Action = {
    type: actionTypes.VALIDATION_SUCCESS;
} | {
    type: actionTypes.VALIDATION_ERROR;
    errors: Errors;
};
//# sourceMappingURL=types.d.ts.map