import { useState, useMemo } from 'react';
import { setCookie, getCookie } from './cookies';
function useCookie(key, initialValue, opts = {
    permanent: false,
}) {
    const [item, setItem] = useState(getCookie(key) || initialValue);
    const update = useMemo(() => function update(value) {
        setItem(value);
        setCookie(key, value, opts);
    }, [key, opts]);
    return [`${item}`, update];
}
export default useCookie;
