(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react", "./cookies"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const react_1 = require("react");
    const cookies_1 = require("./cookies");
    function useCookie(key, initialValue, opts = {
        permanent: false,
    }) {
        const [item, setItem] = (0, react_1.useState)((0, cookies_1.getCookie)(key) || initialValue);
        const update = (0, react_1.useMemo)(() => function update(value) {
            setItem(value);
            (0, cookies_1.setCookie)(key, value, opts);
        }, [key, opts]);
        return [`${item}`, update];
    }
    exports.default = useCookie;
});
