(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const react_1 = require("react");
    function useDocumentEvent(event, callback) {
        (0, react_1.useEffect)(() => {
            document.addEventListener(event, callback);
            return () => {
                document.removeEventListener(event, callback);
            };
        }, [event, callback]);
    }
    exports.default = useDocumentEvent;
});
