var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "validate.js", "xregexp", "date-fns"], factory);
    }
})(function (require, exports) {
    "use strict";
    var __syncRequire = typeof module === "object" && typeof module.exports === "object";
    Object.defineProperty(exports, "__esModule", { value: true });
    const validate_js_1 = __importDefault(require("validate.js"));
    const xregexp_1 = __importDefault(require("xregexp"));
    const date_fns_1 = require("date-fns");
    const dateRegExp = /^\d{2}\/\d{2}\/\d{4}$/;
    const DEFAULT_DATE_FORMAT = 'MM/dd/yyyy';
    const INVALID_MSG = '^is invalid';
    function isValidDate(str, format) {
        const date = (0, date_fns_1.parse)(str, format, new Date());
        return (0, date_fns_1.isValid)(date);
    }
    validate_js_1.default.extend(validate_js_1.default.validators.datetime, {
        parse: function (value, options) {
            if (!value) {
                return false;
            }
            if (!dateRegExp.test(value)) {
                return true;
            }
            return !isValidDate(value, options.format || DEFAULT_DATE_FORMAT);
        },
        format: function (value) {
            return value;
        },
    });
    validate_js_1.default.validators.customFormat = (value, options) => {
        if (!value) {
            return;
        }
        try {
            const { pattern } = options;
            const ignoreCase = pattern.includes('(?i)');
            const patternStr = pattern
                .replace(/\\A/i, '^')
                .replace(/\\Z/i, '$')
                .replace(/\(\?i\)/g, '');
            const regExp = (0, xregexp_1.default)(patternStr, ignoreCase ? 'i' : undefined);
            const message = options.message || INVALID_MSG;
            if (regExp.test(value)) {
                return;
            }
            return message;
        }
        catch (err) {
            // does nothing
        }
    };
    let phoneNumberModule = null;
    async function loadPhoneNumberModule() {
        if (!phoneNumberModule) {
            phoneNumberModule = await (__syncRequire ? Promise.resolve().then(() => __importStar(require('awesome-phonenumber'))) : new Promise((resolve_1, reject_1) => { require(['awesome-phonenumber'], resolve_1, reject_1); }).then(__importStar));
        }
        return phoneNumberModule;
    }
    validate_js_1.default.validators.phone = (value, { message, country: countryOrCountries = [], mobile = true, strict = true, shouldApplyValidation = () => true, }, _key, attributes) => {
        if (!value || !shouldApplyValidation(value, attributes)) {
            return;
        }
        const countries = Array.isArray(countryOrCountries)
            ? countryOrCountries
            : new Array(countryOrCountries);
        if (!phoneNumberModule) {
            loadPhoneNumberModule().then(() => {
                // does nothing
            });
            return message || INVALID_MSG;
        }
        const { parsePhoneNumber } = phoneNumberModule;
        try {
            const num = parsePhoneNumber(value, { regionCode: countries[0] });
            if (!strict) {
                if (num.possible)
                    return;
                return message || INVALID_MSG;
            }
            const isValidPhone = countries.length === 0
                ? num.valid
                : countries.some((country) => parsePhoneNumber(value, { regionCode: country }).valid);
            if (isValidPhone) {
                if (mobile && !num.typeIsMobile) {
                    return message || '^is not a mobile phone';
                }
                return;
            }
        }
        catch (err) {
            return message || INVALID_MSG;
        }
        return message || INVALID_MSG;
    };
    exports.default = validate_js_1.default;
});
